unsigned short np, ng, digit, digit1;
signed short i;
unsigned short flag, ind, tmp, cont, oldstate = 0;
unsigned short mask(unsigned short num);
unsigned short mask1(unsigned short num);
unsigned short invert (unsigned short num);
void ejercicio1 ();
void ejercicio2 ();
unsigned short conversion(float n);
const inicial = 0x77;
const inicial1 = 0x3E;
const E = 0x79;
const G = 0x7D;


void main() {

   // principal:
    ANSEL = 0x01;                 // All I/O pins are configured as digital except AN0
    ANSELH = 0;
   // PORTA = 0;                     // Turn off both displays
    TRISA = 255;                     // All port A pins are configured as inputs
    PORTB = 0;                     // Turn off all display segments
    TRISB = 0;                     // All port D pins are configured as outputs
    PORTC = 0;                     // Turn off all display segments
    TRISC = 0;                     // All port D pins are configured as outputs
    PORTD = 0;                     // Turn off all display segments
    TRISD = 0;                     // All port D pins are configured as outputs

    do {
       PORTB = 0;
       PORTD = inicial;
       PORTC = inicial1;
       if(RA2_bit){
          ejercicio1();
       }

       if(RA3_bit){
          ejercicio2();
         // Delay_ms(500);
       }


    } while (1);                   // Endless loop
}


 void ejercicio1 (){
  float digitp, temp_res;
  unsigned short result, digit10, digit1, digit, i;

 do {
    temp_res = ADC_Read(0);   // Get 10-bit results of AD conversion
     digitp = (temp_res*5)/1023;
     i = conversion(digitp);
     digit = (char)(i % 10u);
     digit1 = mask(digit);  // Prepare mask for displaying ones
     digit = (char)(i / 10u) % 10u;
     digit10 = mask(digit); // Prepare mask for displaying tens
     Delay_ms(100);

        PORTC = digit1;            // Set mask for displaying ones on PORTD
        PORTD = digit10;           // Set mask for displaying tens on PORTD
        result = i & 0X0F;
        result = invert(result);
        result = result << 4;
        digit1 = i & 0XF0;
        digit1 = digit1 >> 4;
        digit1 = invert(digit1);
        PORTB = result + digit1;

  } while(1);

}


   void ejercicio2(){

      PORTC = 0;
      PORTD = 0;
      PORTB = 0;


      flag = 0;
      do{

               for (i = 1; i<=8; i++) {
               PORTB = mask1(i);
               tmp = PORTB;
               if(RA1_bit)  {
                   flag = 1;
                   ng = i;
                   PORTD = mask(ng);
                   Delay_ms(1000);
                   i = 10;
               }
               Delay_ms(100);

           }

   }while(flag.F0 == 0);

   flag = 0;

   do{

               for (i = 1; i<=8; i++) {
               PORTB = mask1(i) | tmp;
               if(RA4_bit)  {
                   flag = 1;
                   np = i;
                   PORTC = mask(np);
                   Delay_ms(1000);
                   i = 10;
               }
               Delay_ms(100);

           }

   }while(flag.F0 == 0);
   
   Delay_ms(1000);


   if(np == ng){
      for (i = 1; i<= 3; i++) {
          PORTB = 0;
          PORTD = 0;
          PORTC = 0;
          Delay_ms(500);
          PORTD = E;
          PORTC = E;
          PORTB = 255;
          Delay_ms(500);
      }
   }
   else {
        if(ng > np)  {
          PORTD = 0;
          PORTC = 0;
          Delay_ms(250);
          PORTD = G;
          PORTC = mask(1);
          PORTB = 0;
          Delay_ms(500);
          PORTB = 255;
          Delay_ms(500);
         }
         else{
            PORTD = 0;
            PORTC = 0;
            Delay_ms(250);
            PORTD = G;
            PORTC = mask(2);
            for(i = 1; i <= 2; i++) {
            PORTB = 0;
            Delay_ms(500);
            PORTB = 255;
            Delay_ms(500);
            }
         }
   }

  Delay_ms(1000);

}


unsigned short mask(unsigned short num) {
switch (num) {
case 0 : return 0x3F;
case 1 : return 0x06;
case 2 : return 0x5B;
case 3 : return 0x4F;
case 4 : return 0x66;
case 5 : return 0x6D;
case 6 : return 0x7D;
case 7 : return 0x07;
case 8 : return 0x7F;
case 9 : return 0x6F;
}
}

unsigned short conversion(float n){

     unsigned short final;
     float tmpf;

       tmpf = n;

       if(n > 1 && n <=2)
         tmpf = tmpf - 1;


       if(n > 2 && n <=3)
         tmpf = tmpf - 2;


         if(n > 3 && n <=4)
         tmpf = tmpf - 3;


         if(n > 4 && n <=5){
         tmpf = tmpf - 4;
         }


        if (tmpf > 0 && tmpf<= 0.05)
              final = 1;
        else if (tmpf > 0.05 && tmpf<=(0.05*2))
              final = 2;
        else if (tmpf > (0.05*2) && tmpf<=(0.05*3))
              final = 3;
        else if (tmpf > (0.05*3) && tmpf<=(0.05*4))
              final = 4;
        else if (tmpf > (0.05*4) && tmpf<=(0.05*5))
              final = 5;
        else if (tmpf > (0.05*5) && tmpf<=(0.05*6))
              final = 6;
        else if (tmpf > (0.05*6) && tmpf<=(0.05*7))
              final = 7;
        else if (tmpf > (0.05*7) && tmpf<=(0.05*8))
              final = 8;
        else if (tmpf > (0.05*8) && tmpf<=(0.05*9))
              final = 9;
        else if (tmpf > (0.05*9) && tmpf<=(0.05*10))
              final = 10;
        else if (tmpf > (0.05*10) && tmpf<=(0.05*11))
              final = 11;
        else if (tmpf > (0.05*11) && tmpf<=(0.05*12))
              final = 12;
        else if (tmpf > (0.05*12) && tmpf<=(0.05*13))
              final = 13;
        else if (tmpf > (0.05*13) && tmpf<=(0.05*14))
              final = 14;
        else if (tmpf > (0.05*14) && tmpf<=(0.05*15))
              final = 15;
        else if (tmpf > (0.05*15) && tmpf<=(0.05*16))
              final = 16;
        else if (tmpf > (0.05*16) && tmpf<=(0.05*17))
              final = 17;
        else if (tmpf > (0.05*17) && tmpf<=(0.05*18))
              final = 18;
        else if (tmpf > (0.05*18) && tmpf<=(0.05*19))
              final = 19;
        else if (tmpf > (0.05*19) && tmpf<=(0.05*20))
              final = 20;
        else
              final = 0;

        if(n > 1 && n <=2)
             return (final + 20);
        else if(n > 2 && n <=3)
             return (final + 40);
        else if(n > 3 && n <=4)
             return (final + 60);
        else if(n > 4 && n <=5) {
               if(n > 4.85 && n <= 4.925)
                  return 98;
               else if(n > 4.925)
                  return 99;
               else
                  return (final + 80);
             }
        else
             return final;

  }


unsigned short invert (unsigned short num) {
switch (num) {
case 0 : return 0x00;
case 1 : return 0x08;
case 2 : return 0x04;
case 3 : return 0x0C;
case 4 : return 0x02;
case 5 : return 0x0A;
case 6 : return 0x06;
case 7 : return 0x0E;
case 8 : return 0x01;
case 9 : return 0x09;
case 10 : return 0x05;
case 11 : return 0x0D;
case 12 : return 0x03;
case 13 : return 0x0B;
case 14 : return 0x07;
case 15 : return 0x0F;
}
}

unsigned short mask1(unsigned short num) {
switch (num) {
case 1 : return 0x01;
case 2 : return 0x02;
case 3 : return 0x04;
case 4 : return 0x08;
case 5 : return 0x10;
case 6 : return 0x20;
case 7 : return 0x40;
case 8 : return 0x80;
}
}